'' A GUI Slider Control for PropGFX
'' Written by Jeff Ledger / Oldbitcollector

CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

   mouse = 26
   led   = 24
   
  SPRX = 0
  SPRY = 1
  SPRP = 2
  SPRC = 3

VAR

  long  PropGFXInserted    
  word  scr
  long  mousex, mousey

  long  slider1x,slider1y    'Control #1 x,y
  long  rate1                'Control #1 setting
   
OBJ
  Lite     : "GFX_BINARY_Databus"
  rat      : "mouse"
  light    : "E555_LEDEngine.spin"
          
PUB Main | i,ocnt,x,y

  rat.start(mouse, mouse+1) 
   
  repeat

    PropGFXInserted:=0
    Lite.PropGFX_Start
    if(Lite.PropGFX_TestValid<>0)
      Lite.GetID
      PropGFXInserted:=Lite.RequestIDVersion
     
    if PropGFXInserted

      Prepare_Sprites
      return

PUB Prepare_Sprites 


  Lite.SetBasicMode(Lite#PROPGFX_NTSC,Lite#PROPGFX_4BIT_CHAR_MODE,Lite#PROPGFX_0_3D_COGS,Lite#PROPGFX_FILLED_MODE,0)

  Lite.SendBuf(@picchr,$2000,$6000)
  Lite.SendBuf(@picmap,$1800,$800)
  Lite.SendBuf(@picpal,$1600,$100)

  Lite.Set16ColourSprites
  Lite.SendBuf(@sprite_images,$7000,8192)  
  Lite.SendBuf(@sprite_pal,$1700,$100)
  Lite.pokeword(Lite#PROPGFX_SPRCHRPTR,$7000)  


  Lite.SetSprite (50,1,1,0,94)     'Draw Mouse on Screen

  slider1x := 120
  slider1y := 50
  rate1 := 1
  
  
  DRAWCONTROL (1,slider1x,slider1y,rate1) 'Uses 5 Sprites starting at 1 


  STARTDEMO
 


PUB STARTDEMO

  repeat    
     mousex := mousex + rat.delta_x 
     mousey := mousey - rat.delta_y 
     DrawPointer(mousex,mousey)
     light.LEDBrightness(90-rate1, led)  

     '' Check to see if Control #1 Rate Needs to be moved.
     if rat.button(0)and mousex > slider1x+6 and mousex < slider1x+60 and mousey > slider1y and mousey < slider1y+20     
        rate1:=mousex-slider1x-8
        if rate1 > 50
           rate1 := 50
        if rate1 < 1
           rate1 := 1   
        DRAWCONTROL (1,slider1x,slider1y,rate1)      

    
PUB DrawPointer (x,y)

  '' Draw Mouse Pointer
  Lite.SetSprite (50,x,y,0,94)


PUB DRAWCONTROL (window,x,y,rate)

  Lite.SetSprite (window,x,y,0,0)      'Control Background
  window++
  Lite.SetSprite (window,x+16,y,0,2)   'Control Background 
  window++  
  Lite.SetSprite (window,x+32,y,0,2)   'Control Background 
  window++  
  Lite.SetSprite (window,x+48,y,0,4)   'Control Background 
  window++
  Lite.SetSprite (window,x+rate,y,0,6) 'Draw control
  

DAT
sprite_images  file      "sprites.chr"
sprite_pal     file      "sprites.pal"


dat

picchr      file      "backg.chr"
picmap      file      "backg.map"
picpal      file      "backg.pal"